/**
 * Mysql boot script
 * @return {Mysql}
 */
var init = false, loaderready = false;
exports = module.exports = function mysqlLoader(db) {

    var master, slave;
    if (this.config.MYSQL_MASTER_HOST) {
        master = {
             host : this.config.MYSQL_MASTER_HOST
            ,port : this.config.MYSQL_MASTER_PORT
            ,user : this.config.MYSQL_MASTER_USER
            ,pass : this.config.MYSQL_MASTER_PASS
        };
    }
    if (this.config.MYSQL_SLAVE_HOST) {
        slave = {
             host : this.config.MYSQL_SLAVE_HOST
            ,port : this.config.MYSQL_SLAVE_PORT
            ,user : this.config.MYSQL_SLAVE_USER
            ,pass : this.config.MYSQL_SLAVE_PASS
        };
    }

    if (!master) {
        throw new Error('Mysql missing master config. Define MYSQL_MASTER_HOST/USER/PASS/PORT ' +
                        'in the configuration file');
    }

    /**
     * There will be a different connection pool for each db
     */
    db = db || this.config.MYSQL_DEFAULTDB;
    var mysql = this.include(this.kerneldir + 'adaptors/mysql').singleton(db, db, master, slave);

    /**
     * Attach listeners
     */
    if (!init) {
        init = true;

        /**
         * Connect
         */
        this.on('Mysql-connect', function() {
            if (!loaderready) {
                this.emit('loader-ready', 'Mysql');
            } else {
                this.log('Mysql - connected');
            }
        });

        /**
         * Disconnect
         */
        this.on('Mysql-disconnect', function() {
            if (!loaderread) {
                this.emit('loader-ready', 'Mysql');
            } else {
                this.log('Mysql - connected');
            }
        });

        /**
         * Connection error
         */
        this.on('Mysql-connect-error', function(error) {
            this.emit('error', error, true);
        });
    }

    return mysql;
};