/**
 * Rabbit loader
 * return {Rabbit}
 */
var loaderready = false;
exports = module.exports = function rabbitLoader() {

    var rabbit = this.include(this.kerneldir + 'adaptors/rabbit').singleton();

    /**
     * Attach configuration and initiate connection
     */
    if (!rabbit.host.length) {
        rabbit.host = this.config.RABBIT_HOST;
        rabbit.connect();
    }

    /**
     * On connection ready emit to the kernel that the loader is ready, or
     * log that this is a reconnect
     */
    this.on('Rabbit-connected', function() {
        if (!loaderready) {
            this.emit('loader-ready', 'Rabbit');
        } else {
            this.kernel.log('Rabbit connection re-established');
        }
    });

    return rabbit;
};