/**
 * Solr loader script
 * @return {Solr}
 */
var init = false, loaderready = false;
exports = module.exports = function solrLoader(core) {

    var master, slave;
    if (this.config.SOLR_MASTER_HOST) {
        master = {
             host : this.config.SOLR_MASTER_HOST
            ,port : this.config.SOLR_MASTER_PORT
        };
    }
    if (this.config.SOLR_SLAVE_HOST) {
        slave = {
             host : this.config.SOLR_SLAVE_HOST
            ,port : this.config.SOLR_SLAVE_PORT
        };
    }

    if (!master) {
        throw new Error('Solr missing master config. Define SOLR_MASTER_HOST/USER/PASS/PORT/CORE ' +
                        'in the configuration file');
    }

    /**
     * There will be a different connection pair (master/slave) for each core
     */
    core = core || this.config.SOLR_DEFAULT_CORE;
    var solr = this.include(this.kerneldir + 'adaptors/solr').singleton(core, core, master, slave);

    /**
     * Attach listeners
     */
    if (!init) {
        init = true;

        /**
         * Connect
         */
        this.on('Solr-connect', function() {
            if (!loaderready) {
                this.emit('loader-ready', 'Solr');
            } else {
                this.log('Solr - connected');
            }
        });

        /**
         * Connection error
         */
        this.on('Solr-connect-error', function(error) {
            this.emit('error', error, true);
        });
    }

    return solr;
};